const Shell   = imports.gi.Shell;
const GLib    = imports.gi.GLib;
const Meta    = imports.gi.Meta;
const Gio     = imports.gi.Gio;
const Utils   = imports.misc.extensionUtils.getCurrentExtension().imports.utils; 
const mySettings = Utils.getSettings();
const key_bindings = {'toggle-nautilus': function() {_toggleNautilus();}};
const WA_FOLDER = 'default-folder';
var dt = new Date();


function _toggleNautilus() {

	let win = _getWindowActor();

	// Start nautilus + block run new nautilus windows during 1s
	if (win === 'start') {
		if (new Date().getTime() > dt.getTime() ){
			dt.setTime( new Date().getTime() + 1000 );
			_startApplication();
			return;
		}				
	}

        if (!win) {
		dt.setTime( new Date().getTime() + 100 );
		return;
        }
        // minimize/unmaximize + 200ms between 2 minimize call
        if (win.minimized) {
		win.unminimize();
		win.activate(global.get_current_time());
		dt.setTime( new Date().getTime() + 200 );
        } else {
		if (new Date().getTime() > dt.getTime() ){
			dt.setTime( new Date().getTime() + 200 );
			win.minimize();
		}
         }
}



function _startApplication(){
	let folder = this.mySettings.get_string(WA_FOLDER);
	//global.log(folder);
	imports.misc.util.trySpawnCommandLine('/usr/bin/nautilus ' + folder);
}



function _getWindowActor(){
	let ApplicationString = _("nautilus.desktop");
	let window =Shell.AppSystem.get_default().lookup_app(ApplicationString).get_windows()[0];
	if(typeof window == 'undefined') { window = 'start';}
	return window;
}



function init(meta) {
	Utils.initTranslations("toggle_nautilus@kirby33");
}



function enable() {
	dt.setTime(dt.getTime());
	for(key in key_bindings) {
		global.display.add_keybinding(key,mySettings,Meta.KeyBindingFlags.NONE,key_bindings[key]);
	}
}



function disable() {
	for(key in key_bindings) {
		global.display.remove_keybinding(key);
	}
}
